local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

local GetTime = GetTime

a.Rotations = {}
c.RegisterForEvents(a)
s.Spam[AddonName] = function()
    c.Flash(a)
end

local function trackDarkIntent(info)
    if c.InfoMatches(info, "Dark Intent") then
        a.DarkIntentTarget = info.Target
        c.Debug("Event", "Dark Intent target:", info.Target)
    end
end

a.Rotations.Afliction = {
    Spec = 1,
    OffSwitch = "affliction_off",
    
    FlashInCombat = function()
        a.FlashAll(
           "Curse of the Elements",
           "Demon Soul",
           "Summon Doomguard",
           "Soul Swap",
           "Spell Lock")
        a.Flash(
        	"Soul Fire with T13",
            "Shadow Bolt for Shadow and Flame",
            "Haunt for Debuff",
            "Corruption under Haunt",
            "Unstable Affliction",
            "Bane of Agony",
            "Bane of Doom",
            "Haunt",
            "Life Tap",
            "Refresh Bane of Doom",
            "Drain Soul",
            "Shadowflame",
            "Shadow Bolt")
    end,
    
    FlashOutOfCombat = function()
        a.Flash("Create Soulstone")
        a.Flash("Life Tap out of Combat", "Soul Harvest")
    end,
    
    FlashAlways = function()
        a.FlashAll("Dark Intent", "Fel Armor")
        a.Flash("Summon Felhunter", "Soul Link")
    end,
    
    CastSucceeded = trackDarkIntent,
}

a.ImmolateRefresh = 0
a.Rotations.Demonology = {
    Spec = 2,
    OffSwitch = "demonology_off",
    
    FlashInCombat = function()
        a.FlashAll(
            "Felstorm",
            "Curse of the Elements",
            "Metamorphosis",
            "Summon Doomguard",
            "Demon Soul",
            "Axe Toss",
            "Spell Lock")
        a.Flash(
        	"Soul Fire with T13",
            "Immolate",
            "Bane of Doom",
            "Bane of Agony",
            "Summon Felhunter in Combat",
            "Corruption",
            "Shadowflame",
            "Hand of Gul'dan",
            "Immolation Aura",
            "Incinerate under Molten Core",
            "Refresh Bane of Doom",
            "Life Tap",
            "Soul Fire and Soulburn",
            "Soul Fire under Decimation",
            "Incinerate")
    end,
    
    FlashOutOfCombat = function()
        a.FlashAll("Create Soulstone")
        a.Flash("Summon Felguard", "Soul Link")
        a.Flash("Life Tap out of Combat", "Soul Harvest")
    end,
    
    FlashAlways = function()
        a.FlashAll("Dark Intent", "Fel Armor")
    end,
    
    CastSucceeded = trackDarkIntent,
    
    SpellDamage = function(
        spellID, target, amount, critical, spellSchool, damageSchool, periodic)
        
        if spellID == c.GetID("Hand of Gul'dan")
            and s.MyDebuff(c.GetID("Immolate"))
            and c.HasTalent("Cremation") then
            
            a.ImmolateRefresh = GetTime()
            c.Debug("Event", "Immolate Refresh")
        end
    end,
}

a.Rotations.Destruction = {
    Spec = 3,
    OffSwitch = "destro_off",
    
    FlashInCombat = function()
        a.FlashAll(
           "Curse of the Elements",
           "Demon Soul",
           "Summon Doomguard",
           "Spell Lock")
        a.Flash(
            "Soul Fire for Improved Soul Fire",
        	"Soul Fire with T13",
            "Immolate",
            "Conflagrate",
            "Bane of Doom",
            "Bane of Agony",
            "Corruption",
            "Shadowburn",
            "Shadowflame",
            "Soul Fire under Empowered Imp",
            "Chaos Bolt",
            "Refresh Bane of Doom",
            "Life Tap",
            "Incinerate")
    end,
    
    FlashOutOfCombat = function()
        a.Flash("Create Soulstone")
        a.Flash("Life Tap out of Combat", "Soul Harvest")
    end,
    
    FlashAlways = function()
        a.FlashAll("Dark Intent", "Fel Armor")
        a.Flash("Summon Imp", "Soul Link")
    end,
    
    CastSucceeded = trackDarkIntent,
}
